package io.tswf.minecraft.metamorphosis.cpw.modlauncher

import com.google.auto.service.AutoService
import cpw.mods.modlauncher.serviceapi.ILaunchPluginService
import groovy.transform.CompileStatic
import io.tswf.minecraft.metamorphosis.core.transforming.MetamorphosisTransforms
import org.objectweb.asm.Type
import org.objectweb.asm.tree.ClassNode


@AutoService(ILaunchPluginService)
@CompileStatic
class MetamorphosisLaunchPlugin implements ILaunchPluginService {

    public static final EnumSet<Phase> NONE = EnumSet.noneOf(Phase)
    public static final EnumSet<Phase> AFTER = EnumSet.of(Phase.AFTER)

    @Override
    String name() {
        return this.class.name
    }

    @Override
    EnumSet<Phase> handlesClass(Type classType, boolean isEmpty) {
        return isEmpty ? NONE : classType in MetamorphosisTransforms.typesToTransform ? AFTER : NONE
    }

    @Override
    boolean processClass(Phase phase, ClassNode classNode, Type classType, String reason) {
        MetamorphosisTransforms.transformClassNode(classNode)
        return true
    }
}
